﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Runtime.InteropServices;

namespace CSharpDemo
{
    class Duxbury64
    {
        const string LIB_PATH = "brltrn64.dll";

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true)]
        public static extern UInt16 BRLTRN_CreateA(
                 [MarshalAs(UnmanagedType.LPStr)] string lpTranslationTable,
               [MarshalAs(UnmanagedType.LPStr)] string lpScanningTable,
                ref IntPtr lpHandleRet,
                [MarshalAs(UnmanagedType.LPStr)] string lpLicenseFile,
               [MarshalAs(UnmanagedType.LPStr)] string lpChiTab);
        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_CreateW(
                 [MarshalAs(UnmanagedType.LPWStr)] string lpTranslationTable,
               [MarshalAs(UnmanagedType.LPWStr)] string lpScanningTable,
                ref IntPtr lpHandleRet,
                [MarshalAs(UnmanagedType.LPWStr)] string lpLicenseFile,
               [MarshalAs(UnmanagedType.LPWStr)] string  lpChiTab);
        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode, EntryPoint = "BRLTRN_TranslateString")]
        public static extern UInt16 BRLTRN_TranslateStringW(IntPtr hEngine,
                                                           [MarshalAs(UnmanagedType.LPWStr)] string lpInput,
                                                           char[] lpOutput,
                                                UInt16 wOutputSize,
                                                  UInt16 wInputCursorPos,
                                                  ref UInt16 pwOutputCursorPos);
        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode, EntryPoint = "BRLTRN_TranslateString")]
        public static extern UInt16 BRLTRN_TranslateStringA(IntPtr hEngine,
                                                           [MarshalAs(UnmanagedType.LPStr)] string lpInput,
                                                           byte[] lpOutput,
                                                UInt16 wOutputSize,
                                                  UInt16 wInputCursorPos,
                                                  ref UInt16 pwOutputCursorPos);
        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_Map2800(IntPtr hEngine, Int32 onInput, Int32 onOutput);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_GetStateArraySize(out UInt16 stateArraySize);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        unsafe public static extern UInt16 BRLTRN_SetStateBitmapVariableArray(IntPtr hEngine, Int64 * state);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_InputPosFromOutputPos(IntPtr hEngine,
            [MarshalAs(UnmanagedType.LPWStr)] string lpInput,
            UInt16 wOutputPos,
            ref UInt16 wInputPosRet);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_Destroy(IntPtr hEngine);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_TranslateStringEx(IntPtr hEngine,
            Int64[] state,
            [MarshalAs(UnmanagedType.LPWStr)] string lpInput,
            char[] lpOutput,
            UInt16[] inputPositions,
            UInt16 outputSize,
            ref UInt16 outputLen);

        [DllImport(LIB_PATH, BestFitMapping = false, ThrowOnUnmappableChar = true, CharSet = CharSet.Unicode)]
        public static extern UInt16 BRLTRN_CopyDynamicResults(IntPtr hEngine,
            char[] lpOutput,
            UInt16[] inputPositions,
            UInt16 outputSize);
    }
}
